unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils, IniFiles, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Memo1: TMemo;
    Opener1: TOpenDialog;
    Button6: TButton;
    Savka: TSaveDialog;
    Button7: TButton;
    Panel2: TPanel;
    Sects1: TComboBox;
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button11: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Sects1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Sects1DropDown(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    { Private declarations }
    procedure WMGetMinMaxInfo(var Info: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CurFile, CurBase, srgFile: string;
  sCaps, sCods, sHeads: TStrings;
  sysfil, umtfil: TIniFile;
  MasterMode: boolean;
  umttext, sToMove: string;
  itid: byte;


implementation

{$R *.dfm}

procedure TForm1.WMGetMinMaxInfo(var Info:TWMGetMinMaxInfo);
begin
  with Info.MinMaxInfo^ do
  begin
      ptMinTrackSize.x := 500;
      ptMinTrackSize.y := 480;
  end;
  inherited;
end;

procedure ubase (crypted: boolean);
var i: word;
begin
if sCaps.count>0 then
For i:=0 to (sCaps.Count-1) do if crypted = true then
umttext:=AnsiReplaceText (umttext,sCods.Strings[i],sCaps.Strings[i])
else umttext:=AnsiReplaceText (umttext,sCaps.Strings[i],sCods.Strings[i]);
end;

procedure BaseLoad(needfile: string);
var
str1, str2, strTemp: string;
eqp, inflen: byte;
fid: TextFile;
begin
strTemp:=''; str1:=''; str2:='';
If FileExists(needfile) then begin
if sCods <> nil then begin sCods.Clear; sCaps.Clear; end;
eqp:=0; AssignFile(fid, needfile); Reset(fid);
While not eof(fid) do begin
Readln(fid, strTemp);
eqp:=pos('=', strTemp);
if eqp > 1 then begin
str1:=Trim(lowercase(LeftStr(strTemp,eqp-1)));
sCods.Add(str1);
inflen:=Length(strTemp) - eqp;
str2:=RightStr(strTemp, inflen);
sCaps.Add(str2);
end; end;
closefile(fid); end else
ShowMessage ('menu.txt !');
end;

procedure TForm1.Button1Click(Sender: TObject);
var p:word; s1:string;
begin
If Opener1.Execute then begin
CurFile:=Opener1.FileName;
Memo1.Lines.LoadFromFile(CurFile);
if MasterMode=false then Button2.Enabled:=true;

umtfil:=TIniFile.Create(CurFile);
Sects1.Clear; sHeads.Clear;
umtfil.ReadSections(sHeads);
umttext:=sHeads.Text; ubase(true); Sects1.Items.text:=umttext;
Sects1.ItemIndex:=0;
Listbox1.Clear;
s1:=umtfil.ReadString(sHeads.Strings[0],'Items','NO_DATA');
if s1[Length(s1)]<>';' then s1:=s1+';';
repeat
p:=pos(';',s1);
ListBox1.Items.Add(LeftStr(s1,p-1));
s1:=RightStr(s1, Length(s1)-p);
until (Length(s1)<1) or (p=0);
umtfil.Free;
umttext:=ListBox1.Items.Text; ubase(true); ListBox1.Items.Text:=umttext;
Panel2.enabled:=true;
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
If Opener1.Execute then begin
CurBase:=Opener1.FileName;
BaseLoad (CurBase);
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
MasterMode:=false;
sCods := TStringList.Create; sCaps := TStringList.Create;
sHeads := TStringList.Create;
CurBase:='menu.txt';
BaseLoad (CurBase);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
sCods.Free; sCaps.Free; sHeads.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var p:word; s1:string;
begin
Memo1.Lines.SaveToFile(CurFile);

umtfil:=TIniFile.Create(CurFile);
Sects1.Clear; sHeads.Clear;
umtfil.ReadSections(sHeads);
umttext:=sHeads.Text; ubase(true); Sects1.Items.text:=umttext;
Sects1.ItemIndex:=0;
Listbox1.Clear;
s1:=umtfil.ReadString(sHeads.Strings[0],'Items','NO_DATA');
if s1[Length(s1)]<>';' then s1:=s1+';';
repeat
p:=pos(';',s1);
ListBox1.Items.Add(LeftStr(s1,p-1));
s1:=RightStr(s1, Length(s1)-p);
until (Length(s1)<1) or (p=0);
umtfil.Free;
umttext:=ListBox1.Items.Text; ubase(true); ListBox1.Items.Text:=umttext;
Panel2.enabled:=true;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
umttext:=Memo1.Text;
ubase(true);
Memo1.Text:=umttext;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
umttext:=Memo1.Text;
ubase(false);
Memo1.Text:=umttext;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
tmp1, tmp2, tmp3: TStrings;
strt: string; i: byte;
begin
tmp1:=TStringList.Create; tmp2:=TStringList.Create;
tmp3:=TStringList.Create;
If Opener1.Execute then begin
srgFile:=Opener1.FileName;
sysfil:=TIniFile.Create(srgFile);
sysfil.ReadSections(tmp1);
for i:=0 to (tmp1.Count-1) do begin
strt:=sysfil.ReadString(tmp1.Strings[i],'Name','NO_STRING_AVAILABLE');
tmp2.Add(strt); if strt='NO_STRING_AVAILABLE' then
begin tmp1.Delete(i); tmp2.Delete(i); end;
end; sysfil.Free;
for i:=0 to tmp1.Count-1 do
tmp3.Add(tmp1.Strings[i]+'='+tmp2.Strings[i]);
If Savka.Execute then tmp3.SaveToFile(Savka.FileName);
end; tmp1.Free; tmp2.Free; tmp3.Free;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
If button7.Caption='-  -' then begin
Memo1.Visible:=false;
Button4.Enabled:=false; Button5.Enabled:=false;
Panel2.Visible:=true; MasterMode:=true;
Button2.Enabled:=false;
button7.Caption:='-  -';
Form1.Caption:='UserMenuTree Helper - ';
end else begin
Memo1.Visible:=true;
Button4.Enabled:=true; Button5.Enabled:=true;
Panel2.Visible:=false;
MasterMode:=false;
button7.Caption:='-  -';
Form1.Caption:='UserMenuTree Helper - ';
if curFile<>'' then Button2.Enabled:=true else Button2.Enabled:=false;
end;
end;

procedure TForm1.Sects1Click(Sender: TObject);
var p: word; s1: string;
begin
umtfil:=TIniFile.Create(CurFile);
Listbox1.Clear;
s1:=umtfil.ReadString(sHeads.Strings[Sects1.ItemIndex],'Items','NO_DATA');
if s1[Length(s1)]<>';' then s1:=s1+';';
repeat
p:=pos(';',s1);
ListBox1.Items.Add(LeftStr(s1,p-1));
s1:=RightStr(s1, Length(s1)-p);
until (Length(s1)<1) or (p=0);
umtfil.Free;
umttext:=ListBox1.Items.Text; ubase(true); ListBox1.Items.Text:=umttext;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
itid:=ListBox1.ItemIndex;
if (ListBox1.count>0) and (itid<>0) then begin
ListBox1.Items.Move(itid,itid-1);
ListBox1.ItemIndex:=itid-1; end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
itid:=ListBox1.ItemIndex;
if (ListBox1.count>0) and (itid<>ListBox1.Items.Count-1) then begin
ListBox1.Items.Move(itid,itid+1);
ListBox1.ItemIndex:=itid+1; end;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
itid:=ListBox1.ItemIndex;
if (ListBox1.count>0) and (itid>-1) then begin
sToMove:=ListBox1.Items.Strings[itid];
ListBox1.Items.Delete(itid);
ListBox1.ItemIndex:=0;
Edit1.Text:=sToMove; end;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
itid:=ListBox1.ItemIndex;
if (ListBox1.count>0) and (itid>-1) and (sToMove<>'') then begin
ListBox1.Items.Insert(itid,sToMove); ListBox1.ItemIndex:=0; end
else ListBox1.Items.Add(sToMove);
end;

procedure TForm1.Button8Click(Sender: TObject);
var ssav: string; j: word;
begin
if ListBox1.Items.Count>0 then begin
umtfil:=TIniFile.Create(CurFile); ssav:=' ';
umttext:=ListBox1.Items.Text; ubase(false); ListBox1.Items.Text:=umttext;
for j:=0 to ListBox1.Items.Count-1 do
ssav:=ssav+ListBox1.Items.Strings[j]+';';
umttext:=ListBox1.Items.Text; ubase(true); ListBox1.Items.Text:=umttext;
umtfil.WriteString(sHeads.Strings[Sects1.ItemIndex],'Items',ssav);
umtfil.Free; Memo1.Lines.LoadFromFile(CurFile);
end;
end;

procedure TForm1.Sects1DropDown(Sender: TObject);
var ssav: string; j: word;
begin
If CheckBox1.checked=true then begin
if ListBox1.Items.Count>0 then begin
umtfil:=TIniFile.Create(CurFile); ssav:=' ';
umttext:=ListBox1.Items.Text; ubase(false); ListBox1.Items.Text:=umttext;
for j:=0 to ListBox1.Items.Count-1 do
ssav:=ssav+ListBox1.Items.Strings[j]+';';
umttext:=ListBox1.Items.Text; ubase(true); ListBox1.Items.Text:=umttext;
umtfil.WriteString(sHeads.Strings[Sects1.ItemIndex],'Items',ssav);
umtfil.Free; Memo1.Lines.LoadFromFile(CurFile);
end; end;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
itid:=ListBox1.ItemIndex;
if (ListBox1.count>0) and (itid>-1) then begin
sToMove:=ListBox1.Items.Strings[itid];
Edit1.Text:=sToMove; end;
end;

end.
